
// In place array reversal

predicate IsReverse(s : seq<int>, t : seq<int>)
{
    |s| == |t| && forall i: int :: 0 <= i < |s|  ==> s[i] == t[|t| - i - 1]
}




method Reverse(a: array<int>) 
   modifies a
   ensures IsReverse(a[..], old(a[..]))
{
   if a.Length <= 1 { return; }

   var l, r := 0, a.Length - 1;
 
    while l < r
    {

        a[l], a[r] := a[r], a[l]; 
        r := r - 1;
        l := l + 1;
    }
}
