// Two pointer Sum


predicate sorted(a: array<int>, l: int, u: int)
  reads a
  {
    forall i, j :: 0 <= l <= i <= j <= u < a.Length ==> a[i] <= a[j]
  }

predicate TwoSum(a: array<int>, sum: int)
   reads a
{
   exists i,j | 0 <= i < j < a.Length :: a[i] + a[j] == sum
}
method TwoPointerSum(a: array<int>, sum: int) returns (p1: int, p2: int) 
   requires sorted(a, 0, a.Length - 1)
   ensures (p1 == p2 == -1 && !TwoSum(a,sum)) 
           || (0 <= p1 < a.Length && 0 <= p2 < a.Length &&  a[p1] + a[p2] == sum)
{
   if a.Length <= 1 { 
      p1 := -1;
      p2 := -1;
      return; 
   }
   var l, r := 0, a.Length-1;
 
    while l < r
    {
        if (a[l] + a[r] == sum) {
            p1 := l;
            p2 := r;
            return;
        } else if (a[l] + a[r] < sum) {
            l := l + 1; 
        } else {
            r := r - 1;
        }
    }
    p1 := -1;
    p2 := -1;
}

